/**
  Tiny OpenGL/GLUT example program
  Dr. Orion Sky Lawlor, olawlor@acm.org, 2009-01-21 (Public Domain)
*/
#include "GL/glut.h" /* windows, mice, etc.  http://freeglut.sourceforge.net */
#include <stdlib.h> /* for "rand" */
#include <stdio.h> /* for printf */

/* Random Float: Return a random number between 0 and 1 */
float rf(void) { return (rand()&0xffff)*(1.0/0xffff); }

float rotate_x=0, rotate_y=0;

void display(void) /* Draw everything in our window */
{
	glClearColor(0.3,0.5,0.7,1.0); /* clear to a nice blue color */
	glClear(GL_COLOR_BUFFER_BIT);
	
	glRotatef(rotate_x,0,1,0);
	glRotatef(rotate_y,1,0,0);
	
	glPointSize(4.3);
	glBegin(GL_POINTS);
	srand(1);
	for (int p=0;p<100000;p++) {
		glColor3f(rf(),rf(),rf());
		glVertex3f(2*rf()-1,2*rf()-1,2*rf()-1);
	}
	glEnd();
	
	glutSwapBuffers(); /* display everything we've rendered so far */
	glutPostRedisplay(); /* continual animation */
}

void motion(int x, int y) { 
	float scale=0.01; /* degrees rotation/frame per mouse pixel motion */
	rotate_x=scale*(x-glutGet(GLUT_WINDOW_WIDTH)/2); 
	rotate_y=scale*(y-glutGet(GLUT_WINDOW_HEIGHT)/2); 
}

int main(int argc,char **argv) {
	glutInit(&argc,argv);  /* set up GLUT */
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
	glutCreateWindow("TinyDemo"); /* make a window */
	glutDisplayFunc(display); /* here's how to draw the window */
	glutMotionFunc(motion); /* here's how to draw the window */
	glutMainLoop(); /* start drawing */
}
